var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-1197A381-38B5-4276-BA3A-72A86269D37D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Image based lighting</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1197A381-38B5-4276-BA3A-72A86269D37D\"></a><div class=\"head\">\n\
            <h1>Image based lighting</h1>\n\
         </div><a name=\"FIG_7A865FE4F1D4482FB9E406BAF27D2BAB\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-28A08030-B39F-454A-AFD3-EF134879FC19-low.png\"></div>\n\
         <div class=\"section\"><a name=\"SECTION_017D2EB4AF2343CA88E66426CFA239B0\"></a> \n\
            <h2><a name=\"GUID-DE8AB23F-BD9F-4315-B68E-C23EB4F3BD5C\"></a>Classifying a plug-in node as an image light\n\
            </h2> \n\
            <p>When registering a plug-in node, it is possible to opt-in to use the internal hardware\n\
               lighting evaluation for an environment light by specifying a classification with the\n\
               root. This allows the plug-in node to behave like an internal IBL (image) light in\n\
               Maya: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">/drawdb/light/image</pre></div> \n\
            <p>For example: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">/drawdb/light/image/environment</pre></div> \n\
            <p>When specified, a default 3d UI drawing implementation is used. If an explicit override\n\
               classification is supplied, then that override will be used for drawing. \n\
               		\n\
            </p> \n\
            <p>If multiple nodes use an image classification, then only the first will be considered\n\
               to contribute to internal lighting. \n\
               		\n\
            </p> \n\
            <p>The aiSkyDomeLight Arnold for Maya plug-in light uses this classification, and therefore\n\
               supports environment lighting. \n\
               		   \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F57D7913E1AB4F2CA82110E40166EEAD\"></a> \n\
            <h2><a name=\"GUID-9BA2B696-C16B-4E7C-8EFA-53BD9FBA647C\"></a>Evaluation\n\
            </h2> \n\
            <p>The internal hardware lighting evaluation currently supports the following attributes\n\
               if they are defined on the Maya node: \n\
               		\n\
            </p> <a name=\"UL_DA400C830F5C437C9EBD8C5CB51038D9\"></a><ul>\n\
               <li>color: A 3 float color attribute. \n\
                  			 <em class=\"strong\">This attribute must be defined</em>; otherwise, your node will appear black. If a file texture node is connected to this\n\
                  attribute, the disk image will be used as the input environment map. Any other upstream\n\
                  network configuration will be baked and used as the input image. If there is no upstream\n\
                  network, then the attribute color will be used as the input image. The input image\n\
                  is assumed to be in lat-long format. \n\
                  		  \n\
               </li>\n\
               <li>envRotationY: By default, the input image is rotated 180 degrees in Y for lookup.\n\
                  If this attribute exists on the node, then it can be set to a different user defined\n\
                  value. \n\
                  		  \n\
               </li>\n\
               <li>sampling: Specifies the resolution to perform baking of an upstream network as required.\n\
                  Values 1 to 4 correspond to increasing values in image dimension. \n\
                  		  \n\
               </li>\n\
               <li>intensity or exposure: Used to compute color gain which is used during map lookup.\n\
                  \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p>Given the color input, two maps are generated internally for shader usage: an \n\
               		  <em class=\"strong\">irradiance environment map</em> and a \n\
               		  <em class=\"strong\">specular environment map</em>. \n\
               		\n\
            </p> \n\
            <p>The specular map is a 3d map with each Z slice containing samples at different levels\n\
               of specularity. \n\
               		\n\
            </p> \n\
            <p>An example is shown below. These images represent the generated specular 3d map with\n\
               8 levels of sampling. \n\
               		\n\
            </p> <a name=\"FIG_955C7747B3494120B7C3B278AD7B306C\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-25DD03BA-11B8-4C3D-BF2D-E5F1F972BDFD-low.png\"></div> \n\
            <p> </p> <a name=\"FIG_26CE369715DE46BC80145F3957B7B3E3\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-66F2B599-BDB8-40B7-8DBD-8BFBBBC3E749-low.png\"></div> \n\
            <p> </p> \n\
            <p>This image represents the generated irradiance 2d texture. \n\
               		\n\
            </p> <a name=\"FIG_315BAF4E38674B7FAA0EDB189FD9148E\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-C7C01B1F-B2EA-4BCF-B861-23ED7092733E-low.png\"></div> \n\
            <p> </p> \n\
            <p>This image shows the input environment texture. \n\
               		\n\
            </p> <a name=\"FIG_BCE32E813F9042FBBA61621549B79D3F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-66CC7B0F-2432-4108-BA89-2CD6DB2F43AC-low.png\"></div> \n\
         </div>\n\
         <p> </p>\n\
         <p>This image represents a blinn shader using the example environment maps, as specified\n\
            on a plug-in node that is classified as an image light. \n\
            	 \n\
         </p><a name=\"FIG_D1A805B78A384209B58309E396533FA4\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-64FCDFCB-9AB0-4A74-822E-6B78CB9BBAF9-low.png\"></div>\n\
         <div class=\"section\"><a name=\"SECTION_E090CEBC00524102B161E066C61A5E1C\"></a> \n\
            <h2><a name=\"GUID-103BB0E0-D7F9-44B8-82AE-3A5BCEAE9660\"></a>API Access\n\
            </h2> \n\
            <p>When writing shader fragments, environment data can be accessed implicitly by specifying\n\
               input shader properties with the following names: \n\
               		\n\
            </p> <a name=\"UL_6F52197910C24F8689DB317A7987CBDA\"></a><ul>\n\
               <li>IrradianceEnv: values computed from the irradiance map input. \n\
                  		  \n\
               </li>\n\
               <li>SpecularEnv: values computed from the specular environment input. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p>For example, the following is a combiner which takes IrradianceEnv and SpecularEnv\n\
               as inputs to compute a final color. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment uiName=\"myShaderCombiner\" name=\"myShaderCombiner\" type=\"plumbing\" class=\"ShadeFragment\" version=\"1.0\" feature_level=\"0\"&gt;\n\
    &lt;description&gt;&lt;![CDATA[Combines inputs from shader fragments.]]&gt;&lt;/description&gt;\n\
    &lt;properties&gt;\n\
        &lt;float3 name=\"color\" /&gt;\n\
        &lt;float3 name=\"specularColor\" /&gt;\n\
        &lt;float name=\"Ks\" /&gt;\n\
        &lt;float name=\"Kd\" /&gt;\n\
        &lt;float3 name=\"IrradianceEnv\" /&gt;\n\
        &lt;float3 name=\"SpecularEnv\" /&gt;\n\
    &lt;/properties&gt;\n\
    &lt;values&gt;\n\
        &lt;float3 name=\"color\" value=\"1.0 1.0 1.0\" /&gt;\n\
        &lt;float3 name=\"specularColor\" value=\"0.0 0.0 0.0\" /&gt;\n\
        &lt;float name=\"Ks\" value=”0.2”/&gt;\n\
        &lt;float name=\"Kd\" value=“0.8”/&gt;\n\
        &lt;float3 name=\"IrradianceEnv\" value=\"0.0 0.0 0.0\" /&gt;\n\
        &lt;float3 name=\"SpecularEnv\" value=\"0.0 0.0 0.0\" /&gt;\n\
    &lt;/values&gt;\n\
    &lt;outputs&gt;\n\
        &lt;struct name=\"myShaderCombiner\" struct_name=\"mayaSurfaceShaderOutput\" /&gt;\n\
    &lt;/outputs&gt;\n\
    &lt;implementation&gt;\n\
        // Sample implementation using environment inputs\n\
        &lt;implementation render=\"OGSRenderer\" language=\"Cg\" lang_version=\"2.1\"&gt;\n\
            &lt;function_name val=\"myShaderCombiner\" /&gt;\n\
            &lt;source&gt;\n\
                &lt;![CDATA[\n\
                mayaSurfaceShaderOutput myShaderCombiner(\n\
                float3 color,\n\
                float3 specularColor,\n\
                float Ks,\n\
                float Kd,\n\
                float3 IrradianceEnv,\n\
                float3 SpecularEnv)\n\
{\n\
    mayaSurfaceShaderOutput result;\n\
    float3 diffuse = color * IrradianceEnv * Kd;\n\
    float3 specular = specularColor * SpecularEnv * Ks;\n\
\n\
    result.outColor = diffuse + specular;\n\
    result.outTransparency = float3(0.0f, 0.0f, 0.0f);\n\
    result.outGlowColor = float3(0.0f, 0.0f, 0.0f);\n\
    result.outMatteOpacity = float3(-1.0e+06f, -1.0e+06f, -1.0e+06f);\n\
    result.outSurfaceFinal = float4(result.outColor, 1.0f);\n\
    return result;\n\
}</pre></div> \n\
            <p>Implicit binding is performed for viewport and batch rendering if image based lights\n\
               exist in the Maya scene. Implicit environment lighting binding is performed for the\n\
               \n\
               		  <span class=\"MenuCascade\">Material Viewer</span> in the \n\
               		  <span class=\"MenuCascade\">Hypershade</span>, when the Hardware renderer is selected. Hardware swatch rendering does not bind\n\
               any environment lighting. \n\
               		\n\
            </p> \n\
            <p>The \n\
               		  <span class=\"code\" translate=\"no\">kIrradianceEnvironment</span> and \n\
               		  <span class=\"code\" translate=\"no\">kSpecularEnvironment</span> enums on the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getInternalTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#ae73c53b8f05ae3a36dfb3716a7b67f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawContext::getInternalTexture()</a></span> interface allow for explicit access to internal irradiance and specular environment\n\
               maps. \n\
               		\n\
            </p> \n\
            <p>The textures are available for the first image light which is active at the time that\n\
               the draw context is available. \n\
               		\n\
            </p> \n\
         </div>\n\
         <p>  </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";