var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-14691FA8-573F-4205-80E4-063EBB8A14B5\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>The Render Loop</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-14691FA8-573F-4205-80E4-063EBB8A14B5\"></a><div class=\"head\">\n\
            <h1>The Render Loop</h1>\n\
         </div>\n\
         <p><a name=\"GUID-01F4DB22-B8C2-4302-A2FD-279323F55E1E\"></a>A pipeline can be configured based on the requirements for either batch or viewport\n\
            rendering. Each configuration may or may not be invoked and any series of configurations\n\
            may be invoked per ren­der. The logic for a render loop thus consists of all configurations\n\
            executed within a single frame. \n\
         </p>\n\
         <p><a name=\"GUID-9376A549-8BE7-4C35-B0B4-432749B0C217\"></a>In such a scheme, it is possible (and common) for render items to be updated and drawn\n\
            under different <em class=\"strong\">rendering contexts</em> as defined by a configuration. \n\
         </p>\n\
         <p><a name=\"GUID-237AD966-B890-423E-8A70-4C47A9AA86A9\"></a>The rendering context can be logically split into two parts based on available data.\n\
            The available set of data usable at draw time is called the <em class=\"strong\">draw context</em>. \n\
         </p>\n\
         <p><a name=\"GUID-B89F8C39-A7AF-4262-ABF6-31DCDDA4DEFB\"></a>A draw context reflects the underlying GPU context or state. In general, the greatest\n\
            variation in state occurs during the drawing of render items. Examples of variations\n\
            of state include: object-to-world matrix, the bound shader, the current blend state,\n\
            the currently bound textures and so forth. States such as camera matrices and viewport\n\
            dimen­sions are generally constant within a pipeline and thus constant at draw time.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-4AA936F5-41BD-49B8-8CE3-0DA0224CA7AF\"></a>In addition to information available at draw time, the rendering context can also\n\
            track <em class=\"strong\">rendering preferences</em> which includes the layering in of <em class=\"strong\">semantic categorizations</em>. In particular, the context can reflect the display mode catego­rizations as well\n\
            as the logical categorization of objects. Sample display modes include: wireframe,\n\
            shaded, tex­tured, lit and transparent categorizations. For example a render item\n\
            can be explicitly tagged with a semantic indicating that it is “transparent.” Examples\n\
            of the latter include: filled surfaces, UI, grid and overlays. \n\
         </p>\n\
         <p><a name=\"GUID-4B5A9100-220E-4BEE-BE4C-93830BAECBE0\"></a>With these additional concepts, we can extend the previous pipeline description with\n\
            the notion of rendering and draw con­texts, collections of renderable objects as lists,\n\
            and add a Categorization phase: \n\
         </p>\n\
         <p><a name=\"GUID-3F81C349-6005-4908-BAAE-2298A49A38AA\"></a></p><img src=\"images/GUID-5F7C4C1A-2EE5-4150-8A35-57DB05B09222-low.jpg\"><p><a name=\"GUID-8611A0BF-91AF-4E59-ABC5-27CB6BDEAE67\"></a>Figure 9 \n\
         </p>\n\
         <p><a name=\"GUID-EE90660C-6497-4C64-90C3-744DCAF7DD4E\"></a>Categorization makes use of semantics as well as shader and data properties to determine\n\
            whether to produce additional lists. Render items in these lists flow down the pipeline\n\
            in the same fashion as those not filtered into additional lists. \n\
         </p>\n\
         <p><a name=\"GUID-FB352F7C-DD7F-4E4D-886E-E8A7552EB0E4\"></a>Context exists throughout the pipeline with data available for reading or writing\n\
            at specific times. No draw context is provided when it is not required. In particular,\n\
            no draw context is required during geometry data update. \n\
         </p>\n\
         <p><a name=\"GUID-647F723D-4D94-44E3-A2A8-E8B05EA08DC1\"></a>A concrete example is transparency handling. A transparency list may result from categorization,\n\
            resulting in a draw phase for handling opaque render items and one for handling transparent\n\
            items. Often, even with the old system, plug-ins do not take into consideration that\n\
            they may be drawn more than once and with different contexts. This is a common occurrence\n\
            which may occur for various reasons based on the rendering configuration. \n\
         </p>\n\
         <p><a name=\"GUID-68E4F574-11A0-4686-8E6D-5EE055D2559B\"></a>Another example follows, where we present shadow map generation “pass” followed by\n\
            a beauty “pass”. Each pass can be said to have semantics which are relevant for that\n\
            pass. A “pass context” would group such information. Each runs a pipeline with its\n\
            own configuration parameters. In total, a render item could be drawn 2 or more times.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-7AD8AEC7-3959-4500-B74E-0DACAADF8663\"></a></p><img src=\"images/GUID-E13C62CE-2BAA-4F14-8F97-8640DB79CA6F-low.jpg\"><p><a name=\"GUID-305FEA74-6B77-4332-82AE-39F5763E850F\"></a>Figure 10 \n\
         </p>\n\
         <p><a name=\"GUID-F21227C3-50D3-4CB0-9332-3E72244C36DC\"></a>In the shadow map generation pipeline the render context would have a camera based\n\
            on the light casting the shadow. The pass context would indicate rendering is occurring\n\
            to create shadow maps. The categorization would prune out everything except “shadow\n\
            casters” and discard all other render items. \n\
         </p>\n\
         <p><a name=\"GUID-3A918A39-C0E9-4021-A226-B0327D56AC11\"></a></p><img src=\"images/GUID-D78DACEE-E6F5-48F8-B983-6DE7EF1C697E-low.jpg\"><p><a name=\"GUID-0A4C274A-3580-41DE-AD7D-06169246B3BD\"></a>Figure 11 \n\
         </p>\n\
         <p><a name=\"GUID-2825663C-E943-4BC6-9DDF-3A92CBA7DEF1\"></a>In the beauty pass pipeline, this particular example extracts all opaque and transparent\n\
            objects and places them into two lists for rendering. All other render items are discarded.\n\
            The beauty pass context would provide information that a beauty pass is being performed\n\
            as well indicate whether the opaque or transparent lists are being rendered. \n\
         </p>\n\
         <p><a name=\"GUID-F88B4B09-5751-4F3E-B841-59F1AAB3AD62\"></a>These are just examples of internal scenarios. As the API is open for customizable\n\
            render loops, plug-ins should not expect to be invoked to update or draw only once\n\
            in a frame render. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";