var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-5F3F9272-0968-4AAD-8F0E-A54230E664A3\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using IEnumerable and LINQ with the Maya .NET API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5F3F9272-0968-4AAD-8F0E-A54230E664A3\"></a><div class=\"head\">\n\
            <h1>Using IEnumerable and LINQ with the Maya .NET API</h1>\n\
         </div>\n\
         <p><a name=\"GUID-61651C63-FD86-4F34-8AE2-1F31CAB9FB7D\"></a>Many classes in the Maya .NET API implement the <span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span> interface. Some examples include helper classes like <span class=\"code\" translate=\"no\">MCGeometry</span>, <span class=\"code\" translate=\"no\">MCDag</span>, and <span class=\"code\" translate=\"no\">MCDependencyGraph</span>, as well as the various Maya array classes such <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MColorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_color_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_color_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MColorArray</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatPointArray</a></span>, and so forth. To see all classes that implement <span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span> you can use the Object Browser to search for <span class=\"code\" translate=\"no\">GetEnumerator()</span>. \n\
         </p><a name=\"FIG_0374F6EFA69A4E638929B44228D8AD1A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-DE6089A3-D614-4230-B51F-547914053577-low.png\"></div>\n\
         <p><a name=\"GUID-31C8B35A-F059-4B1C-8929-201DDD14B000\"></a>Any class that implements a <span class=\"code\" translate=\"no\">GetEnumerator()</span> function (including functions that implement <span class=\"code\" translate=\"no\">IEnumerable</span>) and returns a class that conforms to the <span class=\"code\" translate=\"no\">IEnumerator</span> interface can be used with the <span class=\"code\" translate=\"no\">foreach</span> keyword. For example, with objects selected in the scene, the following code snippet\n\
            displays the path names of all selected objects. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach (var s in MGlobal.activeSelectionList)\n\
           MGlobal.displayInfo(s.partialPathName);</pre></div>\n\
         <p><a name=\"GUID-124EBCC7-04F6-458C-BFBD-82CFC9A5D8BB\"></a>If the <span class=\"code\" translate=\"no\">System.Linq</span> namespace is imported, then the LINQ extension methods can be used with all collections\n\
            that implement <span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span>. For example, the following code snippet returns all selected meshes. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = MGlobal.activeSelectionList.Where(p =&gt; p.hasFn(MFn.Type.kMesh)).Select(p =&gt; new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a>(p)); </pre></div>\n\
         <p><a name=\"GUID-C8ABA92F-787F-406C-B9D2-CD7D5B3B0E77\"></a>This is called the “method syntax”. The other syntax supported by LINQ is called “query\n\
            syntax”. The following snippet is equivalent to the previous: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = from p in MGlobal.activeSelectionList where p.hasFn(MFn.Type.kMesh) select new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a>(p);</pre></div>\n\
         <p><a name=\"GUID-73774C23-7CEF-43FD-9738-C79B31C50242\"></a>For more examples using LINQ, see the DAGExplorer example under the <span class=\"code\" translate=\"no\">devkit\\dotnet\\wpfexamples</span> folder of your Developer Kit installation. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";