var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-660EF1ED-1FA5-4275-AF5D-1E6F9574E2BB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Writing your own .NET plug-in</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-660EF1ED-1FA5-4275-AF5D-1E6F9574E2BB\"></a><div class=\"head\">\n\
            <h1>Writing your own .NET plug-in</h1>\n\
         </div>\n\
         <p><a name=\"GUID-5190C9A6-960F-4A83-A129-C5429CB88D94\"></a> The Maya .NET SDK is available in 64-bit only. Ensure that your Maya .NET plug-in\n\
            projects are also compiled in x64. \n\
         </p>\n\
         <p><a name=\"GUID-FCAA8842-8123-4B58-8D8C-7DD8A98837FD\"></a>The plug-in must implement the <span class=\"code\" translate=\"no\">Autodesk.Maya.OpenMaya.IExtensionPlugin</span> interface. It can be a default implementation that does nothing. \n\
         </p>\n\
         <p><a name=\"GUID-D8D6FC95-AEC3-4804-A766-719559D35628\"></a>The SDK searches for the first class implementing this interface, but to accelerate\n\
            the discovery of the <span class=\"code\" translate=\"no\">IExtensionPlugin</span> implementation, .NET plug-ins may optionally contain a single <span class=\"code\" translate=\"no\">ExtensionPlugin</span> assembly attribute, as so: \n\
         </p>\n\
         <p><a name=\"GUID-A82ACDDB-6172-4250-BC39-A8C34EB0DAE4\"></a> <span class=\"code\" translate=\"no\"> [assembly: ExtensionPlugin(typeof(MayaNetPlugin.helloWorldPlugin), \"Autodesk\", \"1.0\",\n\
               \"Any\")]</span> \n\
         </p>\n\
         <p><a name=\"GUID-E9FB8FAD-E6A8-4B8E-B811-3167BE09C8DC\"></a>For more information regarding assembly attributes, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-D018E091-75A3-4BAC-A9AB-C44EF83BDD43.htm\">Using .Net assembly attributes</a></span>. \n\
         </p>\n\
         <p><a name=\"GUID-6B6044DB-801F-4CCF-A3E2-ECBE104631A4\"></a>This assembly attribute can appear in any source file of your library outside of the\n\
            namespace, usually after the using declarations. \n\
         </p>\n\
         <p><a name=\"GUID-9AC77F92-5D67-40AD-90B6-1A595D186D73\"></a>A plug-in library can contain any number of custom .NET commands, or .NET nodes. \n\
         </p>\n\
         <p><a name=\"GUID-4DA2C6D1-573F-48E7-8806-B94C50C8F03B\"></a>The documentation for the Maya .NET SDK methods support Intellisense, and pops up\n\
            as you type your code. \n\
         </p>\n\
         <div><a name=\"GUID-62573DC9-6E25-4063-A46B-9316A0FAF812\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <a name=\"UL_4F959ED0768948F79D18402969291A42\"></a><ul>\n\
                  <li> \n\
                     <p><a name=\"GUID-5153C343-A487-45DE-8A61-64687BA374B9\"></a>When creating your custom .NET plug-in project, you must set the <em class=\"strong\">Copy Local</em> property of the Maya assembly references to false. \n\
                     </p> \n\
                     <p><a name=\"GUID-3D1E1114-E09A-4819-A114-47F9EAF8F1A1\"></a>When the <em class=\"mild\">Copy Local</em> property is enabled (default), Visual Studio copies the references that are required\n\
                        to run your code to the <span class=\"code\" translate=\"no\">\\bin</span> output folder of your .NET project, and will load them each time. However, because\n\
                        your plug-in will run in Maya, the references are already available with the Maya\n\
                        install and loaded. \n\
                     </p> \n\
                     <p><a name=\"GUID-E8E2214D-F226-479C-93DE-38B448387791\"></a>Your plug-in may fail to initialize as a result. \n\
                     </p> \n\
                     <p><a name=\"GUID-85CF6AF4-7B73-42E9-B43A-B36271E47C9B\"></a>To set <em class=\"mild\">Copy Local</em> to false, right-click your reference in the Solution Explorer in Visual Studio. Select\n\
                        Properties, then set ‘Copy Local’ to false in the Properties window that appears.\n\
                        \n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <p><a name=\"GUID-2E1894B4-4489-421B-B313-7B382DB1FBE3\"></a>If your plug-in references assemblies that are not in the Maya <span class=\"code\" translate=\"no\">bin</span> folder, you must add the path of these assemblies to the PATH environment variable\n\
                        in order for Maya to load your plug-in. \n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
            </div>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_FB407CB142394E47A6847C8619DF753A\"></a> \n\
            <h2><a name=\"GUID-FFBA370A-39CA-47D2-B1C2-6057A1029DFE\"></a>Comparing object instances\n\
            </h2> \n\
            <p><a name=\"GUID-7D4A613F-4446-49D6-802A-B89253D602B0\"></a>Comparing two object references using <em class=\"strong\">==</em> or <em class=\"strong\">!=</em> may not work as expected in all cases. For example, an object <em class=\"mild\">deriving</em> from a .NET base class might be moved to a new memory instance. To compare Maya objects,\n\
               use the member functions <span class=\"code\" translate=\"no\">MObject.equalEqual</span> and <span class=\"code\" translate=\"no\">MObject.notEqual</span> instead. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1D8171AE12014AA397CB68C3B91435C3\"></a> \n\
            <h2><a name=\"GUID-B2FBE247-499E-4724-AF6E-2590BE3351C5\"></a>About internal SWIG types\n\
            </h2> \n\
            <p><a name=\"GUID-ABFD0A8E-5908-40E0-8CB5-58636C20AFA3\"></a>Some types exposed in the API have the substring <em class=\"mild\">swig</em> in their name. These are for internal use only and are not supported. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D2C3CCBCE80547DBB97E17C9E1436477\"></a> \n\
            <h2><a name=\"GUID-1254AC80-FE4C-46FD-B077-57B97BF2684F\"></a>Creating a dockable WPF control\n\
            </h2> \n\
            <p><a name=\"GUID-B3FEB684-DA51-4C70-B3B1-F3C11EF17648\"></a>The <span class=\"code\" translate=\"no\">MDockStation</span> class provides facilities for docking a WPF control in the windows control. See the\n\
               DAGExplorer example under the <span class=\"code\" translate=\"no\">devkit\\dotnet\\wpfexamples</span> folder of your Developer Kit installation. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";