var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-7CD42453-893A-4456-AB85-FDA4F4CAFEC2\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Plug-in Entry Points</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7CD42453-893A-4456-AB85-FDA4F4CAFEC2\"></a><div class=\"head\">\n\
            <h1>Plug-in Entry Points</h1>\n\
         </div>\n\
         <p><a name=\"GUID-1E432B00-E818-4742-8B76-DF59512E78DF\"></a>Assuming some basic understanding of the rendering framework and the basic constructs\n\
            as they are exposed in the API, the remainder of this document concentrates on the\n\
            entry points exposed in the rendering pipeline. \n\
         </p>\n\
         <p><a name=\"GUID-DABFCE35-E312-419D-8B18-AE8D22323786\"></a>Currently there are six main entry points which serve the following purposes: \n\
         </p><a name=\"OL_B5A61B3EFD4D4B8F921CCFCF9B31BE9F\"></a><ol type=\"1\" start=\"1\">\n\
            <li><em class=\"strong\">Geometry Override</em>: Allows a plug-in to define custom geometric data streams to be used to draw a plug-in\n\
               DAG object. \n\
            </li>\n\
            <li><em class=\"strong\">Shader Override</em>: Allows for custom shading to be performed. This is provides, roughly speaking, the\n\
               equivalent functionality of the legacy hardware shader plug-in interface. \n\
            </li>\n\
            <li><em class=\"strong\">Shading Node Override</em> Allows a plug-in to define a hardware shader fragment for use in drawing a software\n\
               shading node in the viewport. \n\
            </li>\n\
            <li><em class=\"strong\">Draw Override</em>: Allows full control over all drawing of a plug-in DAG object. This level of control\n\
               is similar to the legacy plug-in locator or plug-in shape drawing. This is only a\n\
               drawing override. \n\
            </li>\n\
            <li><em class=\"strong\">Sub-scene Override</em>: Allows a plug-in to efficiently define a large number of render items needed to\n\
               draw a single DAG object. \n\
            </li>\n\
            <li><em class=\"strong\">Render Loop Override</em>: Allows custom render loops to be created, which override the internal render loop.\n\
               This is a more formalized way to perform multi-pass rendering. \n\
            </li>\n\
         </ol>\n\
         <p><a name=\"GUID-8F7A8D42-6E89-4663-9083-BF86B9B29C0C\"></a>The following diagram is a basic breakdown of where these entry points reside. Without\n\
            going into too much detail, it shows at which phase of the pipeline an entry point\n\
            resides, with the obvious exception of the render loop override which uses or refines\n\
            the pipeline. \n\
         </p>\n\
         <p><a name=\"GUID-C975BEAD-8090-4993-A25D-8212E6983362\"></a></p><img src=\"images/GUID-E92A692E-3007-48BD-9C6B-276F12282D77-low.jpg\"><p><a name=\"GUID-31903963-7B95-43DD-B70E-7E1A7FEC8818\"></a>Figure 34: Geometry overrides interact at the Update Phase of the pipeline as they\n\
            serve as geometry providers to update render items to be sent down the pipeline. Shader\n\
            overrides and draw overrides interact at the Draw Phase of the pipeline to control\n\
            how things are drawn. For simplicity, sub-scene overrides and shading node overrides\n\
            are not shown; however, they both interact during the Update Phase. \n\
         </p>\n\
         <p><a name=\"GUID-47127463-6B47-4F92-A142-AC4E8102DA77\"></a>Note the usage of the term <em class=\"strong\">attach</em>. These entry points strive to be as unobtrusive as possible by adding or attaching\n\
            additional functionality to existing nodes, as opposed to introducing new node types.\n\
            The main attachment points are for plug-in DAG objects, plug-in shading nodes and\n\
            a renderer. The last refers to the concept of a “renderer” rather than specific renderer\n\
            objects. \n\
         </p>\n\
         <p><a name=\"GUID-AB2CFF93-1863-4235-BE76-C2C00C136EA6\"></a>In this framework, a plug-in can be attached to any entry point without having to\n\
            rely on other plug-ins in other entry points. However, if one or more entry points\n\
            have plug-ins attached, then they work together in a more cohesive manner than any\n\
            older interfaces. For example, in older APIs, the plug-in geometry mechanism (roughly\n\
            a geometry override) and the plug-in shader mechanism (roughly a shader override)\n\
            do not work together. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-A1BA2FCE-DACB-4C61-8340-29B6C6D168C4.htm\">Registration </a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-DF09606A-B690-4FD3-8AA6-22889BA577CF.htm\">The Renderer</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-99836B89-9F16-4AA1-AB47-92A45F3CEEA2.htm\">Geometry Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-63572033-5999-4865-822D-A803A8BED59E.htm\">Effect Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-585F5656-4069-4D82-B9BB-3D1AB2D0DFE6.htm\">Shading Node Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9F212D49-8063-4079-A175-BE3682221FF8.htm\">Draw Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-75A7DB0B-A00E-4E3F-9BD7-436F9ED3B0DC.htm\">Sub-scene Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-32D46A07-2FEA-4D19-8782-DF4C5C8AAB1B.htm\">Render Loop Overrides</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-A9DE3226-0708-4FAA-9B97-C5FF6574688A.htm\">UI draw manager</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-E8A490EC-7538-4A34-8C03-55E56EE92E39.htm\">Manipulators</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-E026E6B4-7F99-440F-8BE7-D4FE0BFAE5ED.htm\">Tool Contexts</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";