var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Command Arguments and Flags</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9\"></a><div class=\"head\">\n\
            <h1>Command Arguments and Flags</h1>\n\
         </div>\n\
         <p><a name=\"GUID-D3B5987A-DF41-44B3-896E-45F63B751FA0\"></a>In this topic, we present the use of arguments and flags within a command. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_D67047E8B8034879B7B6107552D29782\"></a> \n\
            <h2><a name=\"GUID-B99215E9-0E57-40DE-8523-5538F8DA0EF3\"></a>\"Flags\" and \"Command Arguments\"\n\
            </h2> \n\
            <p><a name=\"GUID-A9C044FA-4F0D-49C6-8640-E782B284E3BE\"></a> In the context of the Maya API documentation, the terms \"flag\" and \"command argument\"\n\
               carry specific meanings, which we clarify as follows: \n\
            </p> <a name=\"UL_D3E94AE4D5584E2A927299B8DEE0236E\"></a><ul>\n\
               <li><em class=\"strong\">\"Flag\"</em> - Flags are optional to the normal functioning of a command. Each flag has a long\n\
                  and short name. When used in a MEL command, a flag is prefixed by a hyphen (\'<span class=\"code\" translate=\"no\">-</span>\'). In Python, flags appear as named function arguments without the hyphen. In the\n\
                  following example, the \'<span class=\"code\" translate=\"no\">sx</span>\', \'<span class=\"code\" translate=\"no\">sy</span>\', \'<span class=\"code\" translate=\"no\">sz</span>\', and \'<span class=\"code\" translate=\"no\">h</span>\' flags specify the number of subdivisions along each axis, as well as the height\n\
                  of the cube created with <span class=\"code\" translate=\"no\">cmds.polyCube()</span>: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.polyCube( sx=10, sy=15, sz=5, h=20 )</pre></div> \n\
                  <div><a name=\"GUID-394AB83F-ACAF-4195-8309-1937310EDFB7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A single flag can also accept a tuple of values, for example the <span class=\"code\" translate=\"no\">(r,g,b)</span> value of a color. Each item in a tuple is referred to as a flag <em class=\"mild\">parameter</em>. We expand on parsing multiple flag parameters <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9.htm#SECTION_2C3E671A8E204226900E11E4FC8B2482\">below</a></span>. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">\"Command Argument\"</em> - Command arguments do not have associated names. When they are used in a MEL command,\n\
                  they appear at the end of the call. By contrast, due to the language design of Python,\n\
                  command arguments appear at the beginning of <span class=\"code\" translate=\"no\">maya.cmds</span> function calls. The example below illustrates the difference between <em class=\"mild\">command arguments</em> and <em class=\"mild\">flags</em>: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.group( \'circle1\', \'sphere1\', n=\'group1\' )</pre></div>Here, <span class=\"code\" translate=\"no\">\'circle1\'</span> and <span class=\"code\" translate=\"no\">\'sphere1\'</span> are the command arguments of <span class=\"code\" translate=\"no\">cmds.group()</span>. They are placed before the optional \'<span class=\"code\" translate=\"no\">n</span>\' flag, which is used to specify the name of the resulting group. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-BA94B37C-B520-414D-BF10-876C02B45018\"></a>It is also possible to use the currently selected Maya <em class=\"mild\">objects</em> as arguments to your command. In this case, <em class=\"mild\">command arguments</em> and <em class=\"mild\">objects</em> are incompatible and must not be combined in the syntax definition of your command.\n\
               For more information, consult the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> class documentation. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_604AA254DDD643D2AD0ECF792FC74E58\"></a> \n\
            <h2><a name=\"GUID-90DC2AAE-CF4A-46C5-849B-3436D76277A7\"></a>Sample Command Plug-in: Creating a Flag\n\
            </h2> \n\
            <p><a name=\"GUID-6926A3E6-B048-4502-B41E-EA3D9CC14001\"></a>In the plug-in code below, we create a command which prints the value associated with\n\
               the passed flag. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> class documentation contains additional information about using flags, arguments,\n\
               and selected objects in your commands. \n\
            </p> <a name=\"SECTION_1DE6E95C9B3947B183E974AE8C0BCFAB\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-923D1CDA-9FB9-4461-9DCE-E98B395FCC6B\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlag.py\n\
\n\
import sys\n\
\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithFlag\'\n\
\n\
kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyCommandWithFlagClass() \n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlag.py\' )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_294D7BEA213D4DACAAAA647AAD82FC42\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-F1978485-1E68-439E-AF4E-E30B88C8ED05\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlag.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithFlag\'\n\
\n\
kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagClass() )\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlag.py\' )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <div><a name=\"GUID-3A9760D7-8142-4C0B-ADE7-A7B4B5543228\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For a more practical example of using command arguments, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6031DE26-93CE-445A-AED9-C27C659268E5.htm\">Example: Creating an IK Joint Chain</a></span>. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_732427F029954975A16120F79636242E\"></a> \n\
            <h2><a name=\"GUID-B0E024C5-2EFC-469F-BAFC-006A6AB442DB\"></a>Maya Plug-in Entry and Exit Points - Registering the Argument Syntax\n\
            </h2> \n\
            <p><a name=\"GUID-029D68D1-0BB1-451D-9CC6-FAB1171CAFD3\"></a>Compared to commands which do not process arguments or flags, the <span class=\"code\" translate=\"no\">initializePlugin()</span> entry point needs to be modified to include the command\'s argument syntax. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    </pre></div> \n\
            <p><a name=\"GUID-AE351CCB-6310-4D21-9A1C-D31CBB8BAD9B\"></a> In particular, the call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a64fa4221b58a1bd2937e0bb93e50b3c8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerCommand()</a></span> must have a third parameter: <span class=\"code\" translate=\"no\">syntaxCreator</span>. We list the function parameters of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a64fa4221b58a1bd2937e0bb93e50b3c8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerCommand()</a></span> as follows: \n\
            </p> <a name=\"OL_13DD3816F9D544699FDF784741D38366\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">Command Name</em> - The name of the command: <span class=\"code\" translate=\"no\">\'myCommandWithFlag\'</span>. This determines how the command is executed either through MEL or using the Python\n\
                  <span class=\"code\" translate=\"no\">maya.cmds</span> module. \n\
               </li>\n\
               <li><em class=\"strong\">Command Creation Function Reference</em> - A reference to the function which creates an instance of our command: <span class=\"code\" translate=\"no\">cmdCreator</span>. \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-500ACE4F-A535-4C01-864C-ACE4723BE449\"></a><em class=\"strong\"> Syntax Creation Function</em> - A reference to the function which returns an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> object: <span class=\"code\" translate=\"no\">syntaxCreator</span>. This returned <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> object defines the long and short names of each flag, as well as the expected type(s)\n\
                     of each flag. The short flag name (<span class=\"code\" translate=\"no\">kShortFlagName</span>) should be a one or two letter string prefixed by a hyphen: <span class=\"code\" translate=\"no\">\'-mf\'</span>. The long flag name (<span class=\"code\" translate=\"no\">kLongFlagName</span>) is generally more descriptive and should also be prefixed by a hyphen: <span class=\"code\" translate=\"no\">\'-myFlag\'</span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">kShortFlagName = \'-mf\'\n\
kLongFlagName = \'-myFlag\'\n\
\n\
# ...\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax</pre></div> \n\
                  <p><a name=\"GUID-169A8D77-3B8F-44E2-BD89-D72677943765\"></a> \n\
                     <div><a name=\"GUID-3BC9D170-7199-4406-99CC-7E3FB10455C7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To add a <em class=\"mild\">command argument</em>, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax.addArg()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#ad9b8c499fe50944cb64d6e48d3fef504&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax.addArg()</a></span> function can be used. Consult the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> class documentation for more details. \n\
                        </div>\n\
                     </div> \n\
                  </p> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_04F20935BBBD4FCBA902799123737AFE\"></a> \n\
            <h2><a name=\"GUID-C8AE68FB-3824-43EA-897F-91870838F244\"></a>Command Behavior - Parsing Flags\n\
            </h2> \n\
            <p><a name=\"GUID-B493111A-3CA7-43DC-A183-A688D4C3AA2B\"></a>The <span class=\"code\" translate=\"no\">doIt()</span> method of our command should have some code dedicated to parsing its passed arguments\n\
               and flags. In <span class=\"code\" translate=\"no\">parseArguments()</span>, we instantiate an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> object using an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> object (obtained from <span class=\"code\" translate=\"no\">self.syntax()</span>), and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a></span> object (<span class=\"code\" translate=\"no\">args</span>). We check for the existence of specific flags using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.isFlagSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#a2c282ba91b6e3de0539aa6c1615a1fae&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.isFlagSet()</a></span>. The call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.flagArgumentInt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#acef3d350f63e2a31b1481050f6bed971&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.flagArgumentInt()</a></span> extracts the value associated with a specific flag as an integer. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag\'s value as an integer.\n\
            # We use the \'0\' to index the flag\'s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + \': \' + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...</pre></div> \n\
            <p><a name=\"GUID-3CFAFB25-45D9-4252-BF2C-C34C8229976E\"></a> \n\
               <div><a name=\"GUID-8756CC25-5F10-4EAE-B16D-867764838542\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To parse a <em class=\"mild\">command argument</em>, the <span class=\"code\" translate=\"no\">MArgParser.commandArgument*()</span> functions can be used. Consult the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> class documentation for more details. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2C3E671A8E204226900E11E4FC8B2482\"></a> \n\
            <h2><a name=\"GUID-B5263FF6-9F2A-493E-9299-34E697568FE9\"></a>Parsing Flags with Multiple Parameters\n\
            </h2> \n\
            <p><a name=\"GUID-343FC1D6-115D-4C9F-A4FA-EC682D184626\"></a>Suppose we wanted to parse a flag which contained multiple <em class=\"mild\">parameters</em>, for example a three-dimensional vector, similarly to the following use case: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )</pre></div> \n\
            <p><a name=\"GUID-81E495DE-ADF9-4F18-9B2A-ABA6376DE22D\"></a>To achieve this, we must modify two sections of our code: \n\
            </p> <a name=\"OL_855F4B78DA29405FA7D40CC854127F0D\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">Syntax Creation Function</em> - The syntax creation function would require a tuple of three <span class=\"code\" translate=\"no\">OpenMaya.MSyntax.kDouble</span> parameters in the call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax.addFlag()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a71360d659ff4cb19f3f1bdc1d577a422&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax.addFlag()</a></span>. This new flag syntax definition would tell Maya to expect a tuple of three numbers,\n\
                  instead of just a single number for that flag. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, (<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>) )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax</pre></div> \n\
               </li>\n\
            </ol>\n\
            <div><a name=\"GUID-3FB9EB6F-3974-41B7-864D-029F60AEEE6E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>In the Python API 1.0, the parameters are not passed in a tuple. \n\
               </div>\n\
            </div>\n\
            <ol type=\"1\" start=\"2\">\n\
               <li><em class=\"strong\">Argument Parsing</em> - In the method body of <span class=\"code\" translate=\"no\">parseArguments()</span>, we parse the flag\'s three parameters using indexes <span class=\"code\" translate=\"no\">0</span> to <span class=\"code\" translate=\"no\">2</span> in three separate calls to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser.flagArgumentInt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html#acef3d350f63e2a31b1481050f6bed971&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser.flagArgumentInt()</a></span>: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )</pre></div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_622DEA046BF44005B6A15D805F1DBB44\"></a> \n\
            <h2><a name=\"GUID-7E422871-D0B6-4AF3-995E-68F090F8335E\"></a>Sample Command Plug-in: One Flag with Multiple Parameters \n\
            </h2> \n\
            <p><a name=\"GUID-38A4CF8C-1721-4B63-A2C6-5B28359C13DC\"></a>The following Python code creates a command which prints the three parameters passed\n\
               with the given flag. \n\
            </p> <a name=\"SECTION_4134AA2CB32E4C6AB3A6C4DC1F5315F9\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-6F128CB5-BC72-4BED-AB51-4F255436126F\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithTupleFlag\'\n\
\n\
kShortFlagName = \'-tf\'\n\
kLongFlagName = \'-myTupleFlag\'\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyCommandWithFlagTupleClass()\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, (<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>) )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_161C800069024B1484ACAAE58B321763\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-7D620E11-7F60-4AEE-B453-309F718E86CD\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandWithTupleFlag\'\n\
\n\
kShortFlagName = \'-tf\'\n\
kLongFlagName = \'-myTupleFlag\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following \'pass\' keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        \'\'\' \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        \'\'\'\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgParser</a>( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags\'s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + \'[0]: \' + str( flagParam0 )\n\
            print kLongFlagName + \'[1]: \' + str( flagParam1 )\n\
            print kLongFlagName + \'[2]: \' + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagTupleClass() )\n\
\n\
def syntaxCreator():\n\
    \'\'\' Defines the argument and flag syntax for this command. \'\'\'\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    \n\
    # In this example, our flag will be expecting three <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a> )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCommandFlagTuple.py\' )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";