var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-A8FFDD5C-EBC0-4FAA-84EF-EFA68053B13E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>OGSFX preprocessor directives</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A8FFDD5C-EBC0-4FAA-84EF-EFA68053B13E\"></a><div class=\"head\">\n\
            <h1>OGSFX preprocessor directives </h1>\n\
         </div>\n\
         <p><a name=\"GUID-C74E7BB6-382B-401B-A195-70380179C4FE\"></a> Add the following preprocessor directives to include conditionals in your shader\n\
            code. This is most useful when you only want to run a block of code under certain\n\
            conditions; for example, to execute code only during a specified shader stage; or,\n\
            if to specify the version of OGSFX that should be used to compile the shaders. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_2E21C728DB494247835644E25A1BE1EA\"></a> \n\
            <h2><a name=\"GUID-C832F691-59B1-4EA9-8960-E38555F697FB\"></a>To specify the version of OGSFX used to compile the shader\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#version versionNumber</pre></div> \n\
            <p><a name=\"GUID-D7EE4540-39C1-4053-A6C5-C16D4C28CBA3\"></a>If specified, this directive must be the very first line of the file. It specifies\n\
               the version of OGSFX that should be used to compile/link the shaders. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">OGSFX           GLSL            OpenGL version\n\
#version 100    #version 150    OpenGL 3.2\n\
#version 150    #version 150    OpenGL 3.2\n\
#version 330    #version 330    OpenGL 3.3  * default for Windows and Linux\n\
#version 400    #version 400    OpenGL 4.0\n\
#version 410    #version 410    OpenGL 4.1\n\
#version 420    #version 420    OpenGL 4.2  * default for OS/X\n\
#version 430    #version 430    OpenGL 4.3</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_910536C5CB544639BA6957C0938B406F\"></a> \n\
            <h2><a name=\"GUID-ED382A06-8815-4E28-AE66-5B62413CB1A9\"></a>To enable/disable an internal feature\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma pragmaName : Boolean</pre></div> \n\
            <p><a name=\"GUID-49802652-8E2A-4B85-B324-AA5164AE871B\"></a>Currently, only the following pragma are available: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma Usecb : true            // Use constant buffers (default - true)\n\
#pragma OptimizeUniforms : true // Optimize uniforms by packing them into a single constant buffer (default - true)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_519E631C450C4D0A83FB674173902E0E\"></a> \n\
            <h2><a name=\"GUID-777C22F1-E4B8-4637-A0F9-294B5F975816\"></a>To print error messages\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#error \"Should not be there!\"</pre></div> \n\
            <p><a name=\"GUID-665B7FFE-F70E-423B-85F6-55506F104364\"></a>This directive causes the implementation to write a diagnostic message to the shader’s\n\
               information log. The message will be the tokens following the \n\
               		  <span class=\"code\" translate=\"no\">#error</span> directive, up to the first new-line. The implementation must then consider the shader\n\
               to be ill-formed. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_614D0742CB6F4801A818F41BCEB8F259\"></a> \n\
            <h2><a name=\"GUID-7A4C7FC5-6A51-432F-993A-5387BA4B0F24\"></a>To import additional shader files\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#include \"resources.ogsfh\"</pre></div> \n\
            <p><a name=\"GUID-204545ED-3E85-4957-8ED3-D2EE5F23AAC6\"></a>The \n\
               		  <span class=\"code\" translate=\"no\">#include</span> directive instructs the preprocessor to treat the contents of the specified file\n\
               as if it exists in the source program, at the point where the directive appears. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2963C9B87E15441FACF66B918E4C8AE4\"></a> \n\
            <h2><a name=\"GUID-AA4041D6-79B0-4EBF-A001-CE1C53AA8211\"></a>If conditionals\n\
            </h2> \n\
            <p><a name=\"GUID-44B6A772-B404-42AD-9E24-92BB08D85748\"></a><span class=\"code\" translate=\"no\">#if</span>, \n\
               		  <span class=\"code\" translate=\"no\">#ifdef</span>, \n\
               		  <span class=\"code\" translate=\"no\">#ifndef</span>, \n\
               		  <span class=\"code\" translate=\"no\">#else</span>, \n\
               		  <span class=\"code\" translate=\"no\">#elif</span>, and \n\
               		  <span class=\"code\" translate=\"no\">#endif</span> are defined to operate as are standard for ANSI C preprocessors. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-C1773DF4-AB45-44B6-8DCD-403BDB20C987\"></a><span class=\"code\" translate=\"no\">#define</span> and \n\
               		  <span class=\"code\" translate=\"no\">#undef</span> are defined as are standard for ANSI C preprocessors for macro definitions, both\n\
               with and without macro parameters. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-909794F1-0DB2-4E1E-8649-E025B1FF0A20\"></a>Expressions following \n\
               		  <span class=\"code\" translate=\"no\">#if</span> and \n\
               		  <span class=\"code\" translate=\"no\">#elif</span> are restricted to expressions operating on literal integer constants, plus identifiers\n\
               consumed by the defined operator. Character constants are not supported. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_007AC660359B4BBFA571025952DCF79C\"></a> \n\
            <h2><a name=\"GUID-7BDFA05B-0351-47F4-8044-66F86673CBF0\"></a>Defining shader stages\n\
            </h2> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#vertexshader\n\
#pixelshader\n\
#geometryshader\n\
#tessevalshader\n\
#tesscontrolshader\n\
#endshader</pre></div> \n\
            <p><a name=\"GUID-EAC5BF38-D71C-470D-991D-1556B955BCF8\"></a>These directives can be used to enable code for a specified shader stage: All code\n\
               delimited by the pair \n\
               		  <span class=\"code\" translate=\"no\">#vertexshader ... #endshader</span> is compiled only on the vertex shader. Similarly, code delimited by \n\
               		  <span class=\"code\" translate=\"no\">#pixelshader ... #endshader</span> or \n\
               		  <span class=\"code\" translate=\"no\">#geometryshader ... #endshader</span> is compiled only on the pixel or geometry shader. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";