var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-BA466FAA-0C80-4CAA-9E87-339DFC4AAE1E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Threads</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BA466FAA-0C80-4CAA-9E87-339DFC4AAE1E\"></a><div class=\"head\">\n\
            <h1>Threads</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7124\"></a>This following describes the lowest level threading concepts. An understanding of\n\
            these concepts is essential for any developer working with threaded code.\n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7123\"></a> \n\
            <h2><a name=\"GUID-FF5DB681-D7EC-48E1-8990-A8BD91A1CC0C\"></a>What is a thread?\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7122\"></a>A thread is a new execution space, created and managed by the operating system, which\n\
               contains the following resources that are private to the thread:\n\
            </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-7121\"></a><ul>\n\
               <li>A new stack</li>\n\
               <li>A copy of the processor registers</li>\n\
               <li>An instruction pointer to the first instruction to be executed.</li>\n\
            </ul> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-711D\"></a>Threads do not duplicate the following resources, which remain process global and\n\
               visible to all threads:\n\
            </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-711C\"></a><ul>\n\
               <li>Code</li>\n\
               <li>Data created prior to thread launch</li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7119\"></a> \n\
            <h2><a name=\"GUID-30E5E811-3555-4C8E-8948-DD6A534E83BF\"></a>OS-specific threading libraries\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7118\"></a>These are the lowest level threading implementations available to a user on an operating\n\
               system. Maya uses the following threading libraries:\n\
            </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-7117\"></a><ul>\n\
               <li>Windows: Win32 threads</li>\n\
               <li> Linux: pthreads</li>\n\
               <li>Mac OS X: pthreads</li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7113\"></a> \n\
            <h2><a name=\"GUID-94773851-3B01-4406-897F-82B6068A7621\"></a>Thread management\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7112\"></a>Thread creation is a relatively expensive operation; therefore, it is often useful\n\
               to create threads at the beginning of an application and keep them alive but sleeping\n\
               in a <em class=\"strong\">thread pool</em>. Threads can be activated, run and put back to sleep in the pool at a much lower\n\
               overhead than continually creating new threads when required.\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-7111\"></a> \n\
            <h2><a name=\"GUID-E0CAB002-F0FD-4022-8B38-D308E8B11F2D\"></a>Thread properties\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-7110\"></a>Individual threads have properties that can be controlled by the user. For example,\n\
               thread <em class=\"strong\">priority</em> determines how a thread is scheduled by the OS. A thread with higher priority will\n\
               be given preference by the OS scheduler.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-710F\"></a>Thread <em class=\"strong\">affinity</em> defines what physical processor the thread runs on. Sometimes it might be useful\n\
               to bind a thread to a core so behavior is more deterministic. However, usually OS\n\
               providers recommend allowing the OS to manage processor affinity rather than have\n\
               the user do so.\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";