var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-C16CA3BB-5BCA-473F-9025-8676AB3EF914\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Data Classes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C16CA3BB-5BCA-473F-9025-8676AB3EF914\"></a><div class=\"head\">\n\
            <h1>Data Classes</h1>\n\
         </div>\n\
         <p><a name=\"GUID-F90250B0-EC3E-4D3B-981B-262335EADD63\"></a>These objects describe the renderable geometry in the scene, and present a thin (but\n\
            obvious) abstraction over the underlying GPU resources they represent. They\'re used\n\
            by shapes to describe the renderable geometry (this applies to both Maya\'s internal\n\
            shapes and plugin shapes). And they\'re used by shaders to bind and render the geometry\n\
            (again, this applies to both Maya\'s internal shaders and plugin shaders). This clean\n\
            separation means that custom shaders can work with Maya shapes, Maya shaders can work\n\
            with custom shapes, and custom shaders and custom shapes can also work together. \n\
         </p>\n\
         <p><a name=\"GUID-FA51D70A-0DE1-48C3-8D72-EC2B3A027457\"></a>The basic \"handshake\" between shapes and shaders is as follows: \n\
         </p><a name=\"OL_C2ABEF4F7B4049A7BBE79C393D34A31B\"></a><ol type=\"1\" start=\"1\">\n\
            <li>The shape is queried for the list of render items it needs to render (including multiple\n\
               material sub-geometries, wireframe selection, component display, etc). \n\
            </li>\n\
            <li>The shader is queried for its geometry requirements (e.g. \"I need positions and UV\n\
               set foo\"). \n\
            </li>\n\
            <li>Maya works out the super-set of all the geometry requirements on each shape (based\n\
               on all the render items that use it). \n\
            </li>\n\
            <li>The shape populates all the geometry buffers based on its current state. </li>\n\
            <li>The shader receives the list of render items it needs to render, and it can pull out\n\
               the geometry buffers it needs for each geometry item. \n\
            </li>\n\
         </ol>\n\
         <p><a name=\"GUID-06AA43C0-63E2-4A93-ADC3-EC5B6A7E302C\"></a>However, unlike previous Maya viewports, Viewport 2.0 tries to cache and re-use as\n\
            much data and information as possible - so unless the scene state is changing, only\n\
            the final render call will be used to render the cached state. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_34878E439A58416CACB4738749805A9C\"></a> \n\
            <h2><a name=\"GUID-56C74470-CA98-4C60-B143-C1DD402F9C2F\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-0AA8BCDA-B89E-4BD7-9BF0-EBDDA6B8720E\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> represents the vertex and index data for any renderable geometric entity in Maya.\n\
               These are most commonly shapes (meshes, NURBS surfaces, subdivision surfaces), but\n\
               it may also be used to represent any other in-viewport elements (including the grid,\n\
               manipulators, tool feedback, etc). \n\
            </p> \n\
            <p><a name=\"GUID-7FD6A752-4097-46C9-8F18-DDD32340A7A9\"></a>In the case of DAG objects, each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> instance holds all the renderable data for all instances of a single object. This\n\
               includes all of the vertex and index buffer data that describes the shape’s control\n\
               points. \n\
            </p> \n\
            <p><a name=\"GUID-C828BA6A-B66E-4E4C-8178-894C39EF26EF\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> is used in several places in the Viewport 2.0 API. In some cases it is simply meant\n\
               to provide read-only access to existing geometry data, and in others the user is required\n\
               to fill the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> object with vertex and index data needed to draw a particular object. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_39B64BD7C68C4562A48884704CABD3E3\"></a> \n\
            <h2><a name=\"GUID-5A8A1EF8-1902-40CE-A872-1183AAA2D33C\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-E11CC151-C365-4E21-97A4-AE82392C0A24\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span> is a thin wrapper around a graphics card vertex buffer. Each vertex buffer has a\n\
               name, a semantic (position, normal, uv, etc), and a type (e.g. float3) and this data\n\
               is encapsulated by an instance of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> class. Other than hardware memory and shader interpolant limits, there are no Maya\n\
               limits to the number of vertex buffers that can be added to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> object (e.g. an object can have multiple position streams, multiple normal streams,\n\
               etc) \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_461C80659CD1473DBF9ADDE811485AEC\"></a> \n\
            <h2><a name=\"GUID-96A13954-554C-4701-A2AB-852F60FA47EE\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBuffer</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-99D91308-F922-4844-B109-CF2C0D5E986E\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBuffer</a></span> is the index equivalent of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span>. An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> object can include 0, 1, or multiple index buffers depending on how many renderable\n\
               objects (render items, see below) the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometry</a></span> object represents. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CEBB536B0EC2453AA42FD88E277C5698\"></a> \n\
            <h2><a name=\"GUID-6C833140-B1F0-4D0F-AC98-51D4391B03FA\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometryRequirements</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-9724494D-DA1D-473D-A575-11D64313F7C6\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGeometryRequirements</a></span> describes the geometry streams and index buffers that are required to draw all render\n\
               items associated with a specific object. This class is passed to implementations of\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span> to indicate what geometry needs to be produced. \n\
            </p> \n\
            <p><a name=\"GUID-8A86AFB7-0DD5-4D0E-BEB8-043457F64F31\"></a>The list of vertex buffers stored on this object is formed by taking the union of\n\
               the requirements from all of the render items stored on the object. Any one render\n\
               item can be examined to determine the requirements for that item; however, all data\n\
               is shared where possible. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_B753180192384EC6BBABFF2C3CA7BC76\"></a> \n\
            <h2><a name=\"GUID-F29E91D0-4356-425E-A8C9-BB76598C8F10\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-6196F194-78E8-44A7-9BA2-A90A64275A10\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span> describes a renderable primitive, something that is actually rendered on the graphics\n\
               card. Each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span> includes: \n\
            </p> <a name=\"UL_8DAA2F8829EA46A99174C297FB92123B\"></a><ul>\n\
               <li>The render primitive to use (e.g. indexed triangles, points, lines, triangle strips,\n\
                  etc.) \n\
               </li>\n\
               <li>An index buffer to use when rendering that primitive. </li>\n\
               <li>A list of which vertex buffers to render. </li>\n\
               <li>The shader to use (may be overridden in some cases). </li>\n\
               <li>A set of display mode/options to control which render passes and viewports this render\n\
                  item is visible in (e.g. so one viewport can display wireframe while another displays\n\
                  shaded mode). \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-B68A8264-6B0A-4062-A34E-6A880003500F\"></a>The render item is deliberately a light weight object to make it easy and efficient\n\
               to share heavy vertex/index data across multiple renders of the same underlying geometry\n\
               (e.g. to draw wireframe over shaded mode re-using the same position data). \n\
            </p> \n\
            <p><a name=\"GUID-D307B8BE-D8E3-4709-85CE-11BAAD4FD368\"></a>Some render passes (e.g. shadow pass, depth pass) will use the display mode/option\n\
               to select which render items to display, but will override the material in order to\n\
               render other surface properties. \n\
            </p> \n\
            <p><a name=\"GUID-36B1BC37-D475-4959-8C21-2437ECA8BD27\"></a>The shader associated with a render item is what drives the geometry requirements\n\
               that need to be fulfilled to draw the object. These requirements can be retrieved\n\
               from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span> and will be nonempty if a shader is assigned. Shaders can be acquired through <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MShaderManager</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-D699AC30-BF93-4D18-AEEC-4E1E78E75590\"></a>Render items may be enabled or disabled to allow or prevent them to draw without needing\n\
               to delete the render item and recreate it later. \n\
            </p> \n\
            <p><a name=\"GUID-068C6194-1D0D-4E0F-99D8-16FAB539AE9A\"></a>Render items are created in two places. First, Maya automatically creates one render\n\
               item for each shader assignment to each instance of each object. These render items\n\
               may be disabled but not removed and are automatically associated with the shader described\n\
               by the Maya shading assignment. Second, users may add additional render items per\n\
               instance for any custom purpose. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D56B80CAD5F24E05AA44DE53B8C9BC7C\"></a> \n\
            <h2><a name=\"GUID-E5A1401C-D572-4BBC-8F74-07612C66F67C\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-E3FF176F-80B0-47FD-8E15-A1D83410543F\"></a>This class is used to describe the properties of either an existing vertex buffer\n\
               or one that needs to be created (i.e. to specify geometry requirements). \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_FD4C5E8B8AAB4C2FAFB712363DEC2281\"></a> \n\
            <h2><a name=\"GUID-F15DC3B1-3AFD-4AC7-8A5C-ADBD9B9E581F\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptorList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptorList</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-3E8618D6-6AFE-4B53-9391-84E760B82C1C\"></a> A simple list of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> objects. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_25364E568DE244CF86FDCEC034DE303C\"></a> \n\
            <h2><a name=\"GUID-76FB1337-9703-4586-BB12-E5D605FBC986\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItemList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItemList</a></span> \n\
            </h2> \n\
            <p><a name=\"GUID-C0036768-A011-4C9F-A68F-3EFF9680C4B8\"></a> A simple list of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderItem</a></span> objects. Each item is owned by the list. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";