var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-CEC1D76B-7568-4DCA-B80B-1DE49362492C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using the loadUI Command</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CEC1D76B-7568-4DCA-B80B-1DE49362492C\"></a><div class=\"head\">\n\
            <h1>Using the loadUI Command</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716F\"></a>Qt\'s Designer tool can be used to interactively create graphical interfaces and save\n\
            them out in a portable XML format. Maya provides the <span class=\"code\" translate=\"no\">loadUI</span> command which can be used by MEL and Python scripts to load these files into Maya\n\
            and translate them, where possible, into standard Maya controls. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716E\"></a>The following image demonstrates Qt Designer being used to create a simple dialog\n\
            consisting of a combo-box, a text field, their associated labels, and a button box\n\
            below with two buttons. \n\
         </p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-C8313CB8-2CF2-4064-93AC-DE380B3EF67B-low.png\"></div>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716C\"></a>Assuming that the dialog is saved out to the file <span class=\"code\" translate=\"no\">/home/autodesk/createDialog.ui</span>, then it can be loaded into Maya and displayed using the following MEL commands:\n\
            \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
string $dialog = `loadUI -uiFile \"/home/autodesk/createDialog.ui\"`;\n\
showWindow $dialog;\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716B\"></a>Or, in Python: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.cmds as cmds\n\
dialog = cmds.loadUI(uiFile=\'/home/autodesk/createDialog.ui\')\n\
cmds.showWindow(dialog)\n\
</pre></div>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-716A\"></a> The <span class=\"code\" translate=\"no\">loadUI</span> command creates the widgets specified in the file by executing their corresponding\n\
            Maya commands. For example, the two labels in the example above are created using\n\
            Maya\'s <span class=\"code\" translate=\"no\">text</span> command, the comboBox control is created using the <span class=\"code\" translate=\"no\">optionMenu</span> command, and the input field is created with the <span class=\"code\" translate=\"no\">textField</span> command. As a result, those controls can be subsequently manipulated in MEL and Python\n\
            scripts as if they had been created in the normal way. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7169\"></a>Flags can be passed to the command used to create a control by adding dynamic properties\n\
            to the widget within Qt Designer. The name of the property should match that of the\n\
            flag, including the leading hyphen, for example <em class=\"mild\">-width</em>. If you want the control to be created using Python rather than MEL, then replace\n\
            the leading hyphen with a + instead, for example, <em class=\"mild\">+width</em>. If you specify both MEL and Python flag properties for the same widget, the behavior\n\
            is undefined and therefore may result in errors. If the flag takes one or more arguments,\n\
            specify them as the property value. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7168\"></a>The image below shows the <em class=\"strong\">-changeCommand</em> property being added to the comboBox in Qt Designer. \n\
         </p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7167\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-93951B03-25C8-4223-B03F-AFC98BEA4B09-low.png\"></div>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7166\"></a>When the corresponding optionMenu control is created, its <em class=\"strong\">-changeCommand</em> flag will be set to execute the command string \"newObjectType()\". \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7165\"></a>If the <span class=\"code\" translate=\"no\">loadUI</span> command encounters a Qt widget for which there is no equivalent Maya control, the\n\
            Qt widget is still created, but you cannot access it from MEL or Python scripts. An\n\
            example of this is the button box at the bottom of the dialog. It uses a QDialogButtonBox\n\
            widget for which there is no equivalent control in Maya. As a result, there is no\n\
            access to either the button box itself or the buttons within it. Had the buttons been\n\
            placed on the dialog individually, without using the button box, then the <span class=\"code\" translate=\"no\">loadUI</span> command would have created them using the Maya <span class=\"code\" translate=\"no\">button</span> commands and they would have been accessible to scripts. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7164\"></a>Any layouts in the file are created as generic layouts and are only accessible within\n\
            Maya using the <span class=\"code\" translate=\"no\">layout</span> command, not the commands for specific types of layouts such as <span class=\"code\" translate=\"no\">formLayout</span>, <span class=\"code\" translate=\"no\">columnLayout</span>, and so forth. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7163\"></a>The name given to a control or layout within Maya is that specified for its <em class=\"strong\">objectName</em> property in Qt Designer. The top-level window itself must have a unique name, though,\n\
            so if the specified name is already in use, the <span class=\"code\" translate=\"no\">loadUI</span> command will add a number to the end of it to make it unique. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";