var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-F584322E-4A12-4995-9F4E-A38D4331808F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Maya Architecture Overview</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F584322E-4A12-4995-9F4E-A38D4331808F\"></a><div class=\"head\">\n\
            <h1>Maya Architecture Overview</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_B342ED601C44442B9B5CB5F0973A289B\"></a> \n\
            <h2><a name=\"GUID-51F07AC4-2E93-4919-99DF-4AF6C312D3DD\"></a>Maya Architecture Overview\n\
            </h2> \n\
            <p><a name=\"GUID-4099265C-22FD-4B0A-8CAE-E2AD69B396E4\"></a>Maya is designed to be an open, flexible and extensible product. \n\
            </p> \n\
            <p><a name=\"GUID-B2F58046-0DDD-4C72-B77A-9FE178B29011\"></a>The APIs of Maya and its command scripting languages (MEL and Python) are key to the\n\
               software being open and extensible. During the initial design of Maya, Maya and its\n\
               C++ API were built together in order to maximize its extensibility. To fully appreciate\n\
               this relationship, you must first understand the architecture of Maya. \n\
            </p> \n\
            <p><a name=\"GUID-62BD5D76-4E37-42CA-8605-9330DFA4F353\"></a>At the lowest level, Maya is a very efficient database for storing graphical information.\n\
               This database is called the Dependency Graph (DG). Information in the DG is stored\n\
               in objects called nodes. Nodes have properties called attributes that store the configurable\n\
               characteristics of each node. Similar types of attributes can be connected together,\n\
               letting data flow from one node to another. \n\
            </p> \n\
            <p><a name=\"GUID-8DF864B9-BDA7-45EC-AF88-CFD2989FD603\"></a>For example, a nurbsCurve node has an attribute that contains a NURBS curve. This\n\
               attribute can be connected to the input curve attribute of a revolve node. The revolve\n\
               node also has input attributes that describe the sweep angle and the axis that it\n\
               would revolve around. The output attribute of the revolve node is a NURBS surface.\n\
               You can connect this attribute to the input of a nurbsSurface node that knows how\n\
               to draw a surface. You can then make the nurbsSurface node a child of a transform\n\
               node that knows how to position objects in 3D space. \n\
            </p> \n\
            <p><a name=\"GUID-5BA3BCF6-64B3-4183-9133-CF60FD7327D0\"></a>This data flow is, in fact, a mechanism for implementing construction history. If\n\
               you change one of the inputs to any node that participates in the construction of\n\
               the revolved surface, the DG recomputes only the parts of the history that are affected\n\
               in order to update the surface. The DG keeps a clear record of what affects what,\n\
               so that it only recomputes the graph as necessary. \n\
            </p> \n\
            <p><a name=\"GUID-FDE8DA30-F182-4D2E-8BD3-36D70906464F\"></a>There are over 600 built-in nodes shipped as part of the Maya system. The Maya Help\n\
               comes with documentation called the Node and Attribute Reference that describes each\n\
               of these nodes and their attributes. \n\
            </p> \n\
            <p><a name=\"GUID-3DD31FE7-5E99-465D-96AF-3DE3E8BDA12C\"></a>Working directly at the DG level gives you the maximum amount of flexibility and power,\n\
               but it is limiting. Fortunately, you are not required to work directly at this level\n\
               because Maya also comes with over 900 commands that can do this for you. These commands\n\
               create DG nodes, set and connect their attributes, and create the transform nodes\n\
               that position objects. For example, there is a revolve command that takes sweep angles\n\
               and an axis as arguments, and builds the revolve network described above from a selected\n\
               NURBS curve. This command handles all the low level details for you. The Maya Help\n\
               comes with documentation called the MEL Command Reference that describes all the built-in\n\
               Maya commands and their arguments. \n\
            </p> \n\
            <p><a name=\"GUID-97BE7B82-23CC-45AB-A32E-205B55A73D70\"></a>About 200 of the Maya commands are UI creation commands that let you build windows,\n\
               menus, buttons, icons, and so on. Maya itself contains a large number of scripts that\n\
               it uses to build its UI. In addition to the revolve node and the revolve command,\n\
               there is a menu item called \"Revolve\", and a revolve icon on the UI shelf. The menu\n\
               item or icon executes the command that in turn creates the DG network. Scripting is\n\
               used to implement approximately 98% of the UI of Maya. \n\
            </p> \n\
            <p><a name=\"GUID-25789E39-0A35-4966-8602-4A0789884288\"></a>At a high level (for example, for technical directors), Maya provides an extremely\n\
               customizable environment. MEL and Python are very powerful scripting languages that\n\
               can be used to expand an artist\'s palette of tools. Both are also very powerful UI\n\
               creation languages. For example, you can create a specific UI for each character being\n\
               animated in your scene and this can significantly increase your productivity. \n\
            </p> \n\
            <p><a name=\"GUID-C02897DF-455F-4C8C-9FF0-5E7A8AF17407\"></a>Finally, if the script you want to write requires a Maya command that does not exist,\n\
               or if your script would be much simpler to write if a node with a certain set of characteristics\n\
               existed, you can add such commands and nodes to Maya using the API. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_63FCBEC5C2344A1FBDD1D3EA2047A17B\"></a> \n\
            <h2><a name=\"GUID-125446A2-62E1-4AC4-93DF-8D957D271C80\"></a>Maya API and Maya Python API\n\
            </h2> \n\
            <p><a name=\"GUID-9D412239-C4B3-4A4B-B66A-52BFA637A35D\"></a> The APIs of Maya closely mirror the underlying architecture of Maya so that the scene\n\
               graph and DG, which manage the way data is processed, are visible through the Maya\n\
               API in a manner consistent with their underlying implementation. \n\
            </p> \n\
            <p><a name=\"GUID-AA813C4E-DC95-4E8D-B18F-844D9AB55EBA\"></a>The Maya API is a C++ interface with which developers can write plug-in shared objects\n\
               that may be loaded into Maya at runtime. When they are no longer needed, plug-ins\n\
               can be unloaded. As a result, you can efficiently develop a plug-in by compiling it,\n\
               loading it, testing it, unloading it, changing its source code, recompiling and reloading.\n\
               The same can be done for plug-ins that have been implemented using the Maya Python\n\
               API. \n\
            </p> \n\
            <p><a name=\"GUID-4F8144D4-45D8-4446-B134-3BD92431AD37\"></a>Plug-ins (coded in C++) developed for Maya work in tandem with standard debugging\n\
               environments on Linux ® and Windows operating systems. On Linux, you can launch Maya\n\
               with the -d flag and it will start under the control of the debugger. You can also\n\
               set breakpoints in your plug-in and get stack traces as you would with any other Unix\n\
               ® application. On Windows, you can launch Maya directly from the Microsoft ® Visual\n\
               Studio ® development system and debug the plug-in as you would any other Windows application.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-B39A9DEE-FE56-4C1B-9B31-98364A484E5C\"></a>The APIs of Maya provide access to a significant portion of the functionality of Maya.\n\
               This includes, but is not limited to, the ability to query and modify existing data\n\
               such as geometry, transforms, hierarchies, scene graph, and DG nodes. Also, these\n\
               APIs let you create new objects such as shader types available to the renderer, and\n\
               let you draw in OpenGL ® . The OpenMaya API also includes a class that permits the\n\
               customization of a shape\'s hardware rendered appearance so that tools can be developed\n\
               to let artists see how their work will appear in a real time environment. Plug-in\n\
               features can be added and removed at any time using scripting language commands. Plug-ins\n\
               can operate in either of the two modes of operation of Maya: interactive or batch\n\
               mode. The Maya API is available in a standalone form for writing separate standalone\n\
               applications. These applications can read and write the ASCII and binary scene files\n\
               of Maya and perform operations on the data therein. \n\
            </p> \n\
            <p><a name=\"GUID-4E5082D9-F939-46EC-BA4A-ADA6ABE72988\"></a>As described in the previous section, you normally add a new command or node (or both)\n\
               to Maya using one of the APIs and then create a script that provides a UI for the\n\
               new feature. For example, you can use one of the APIs to create a new type of node,\n\
               then write a new command that creates an instance of the node and places it in the\n\
               scene and connects it to the appropriate nodes. Finally, you can write a MEL or Python\n\
               script that inserts the command in a menu so that you can access it. \n\
            </p> \n\
            <p><a name=\"GUID-FAD93B38-672E-425D-89E4-156C0BD16DF0\"></a>The Maya API and the Maya Python API are designed to be platform neutral. In most\n\
               cases, no source code changes are required to \"port\" a plug-in between Linux, Windows\n\
               or Mac OS X. Normally, platform specific code is only required when creating or manipulating\n\
               windows without using the platform independent UI creation abilities of scripting,\n\
               or when using a platform specific 3rd party library. \n\
            </p> \n\
            <p><a name=\"GUID-2DF264C4-26EE-40C1-A954-C278E4DDA329\"></a>Both the Maya API and the Maya Python API provide source code compatibility. Therefore,\n\
               C++ plug-ins written for earlier Maya releases can recompile without any source code\n\
               changes in the current version of Maya. An existing Python plug-in should import and\n\
               run correctly without source code changes if source code compatibility is maintained.\n\
               If source code incompatibility occurs, the documentation for the new release will\n\
               contain detailed instructions on what changes need to be made to the plug-ins. \n\
            </p> \n\
            <p><a name=\"GUID-00CF060A-3D6E-407F-BA34-590E6137B725\"></a>The APIs of Maya use objects and function sets to access internal objects of Maya.\n\
               Objects are very lightweight classes that provide RTTI (Run Time Type Identification)\n\
               and can be used in a type-less manner. A function set is a user owned structure that\n\
               allows operations on Maya owned objects. Since an object is simply a handle that knows\n\
               its type, a function set provides you with a tool that acts upon objects of the right\n\
               type. These function sets usually have names that match the Maya features, such as\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnSkinCluster\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_skin_cluster.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_anim_1_1_m_fn_skin_cluster.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnSkinCluster</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsSurface\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsSurface</a></span>. For example, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnSkinCluster\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_skin_cluster.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_anim_1_1_m_fn_skin_cluster.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnSkinCluster</a></span> class can be instantiated with an object of type <span class=\"code\" translate=\"no\">kSkinCluster</span>, and subsequently can be used to perform operations on that object. The object itself\n\
               is not able to perform any functions without the aid of its function set. \n\
            </p> \n\
            <p><a name=\"GUID-A6C54983-6F8F-4084-8684-BADD4DD2A010\"></a>Proxies let you develop new types of objects. Proxy object classes let you create\n\
               functionality that integrates into Maya as first-class citizens. Examples of proxies\n\
               are: commands, file translators, and new types of shaders. \n\
            </p> \n\
            <p><a name=\"GUID-E2EA0C3D-E51A-43A7-895E-B3604965318E\"></a>The APIs of Maya are very flexible. This flexibility lets you accomplish a particular\n\
               task in a number of ways, and lets you determine where to make the tradeoff between\n\
               speed of development and the performance of the plug-in. With either API, if the performance\n\
               of the plug-in is not critical, then it is possible to quickly prototype a solution\n\
               to a particular problem. If performance is critical, the C++ Maya API should be utilized.\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";