var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-FCEC5148-745B-4D13-8E08-73F8AFAC74E3\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Other types of parallelism</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FCEC5148-745B-4D13-8E08-73F8AFAC74E3\"></a><div class=\"head\">\n\
            <h1>Other types of parallelism</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5564\"></a> \n\
            <h2><a name=\"GUID-0C78C206-94E1-4A2A-9EF0-7DFE13896F74\"></a>Vectorization\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5563\"></a>Vector SSE instructions allow multiple identical operations to be done in parallel\n\
               on adjacent data values. Four floating point operations or two double precision operations\n\
               may be executed at the same time on processors supporting SSE2. Maya requires system\n\
               support for SSE2, so the plug-in writer may assume SSE2 is always available.\n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5562\"></a>SSE2 code can either be written directly in assembler, written using compiler intrinsics,\n\
               or code can be written in C/C++ and the compiler can generate vector instructions.\n\
               If the compiler generates vector SSE the process is known as autovectorization. The\n\
               Intel and gcc compilers support autovectorization, but VC++ currently does not. Obviously\n\
               it is much easier to write high level code and have the compiler generate vector instructions.\n\
               However autovectorizers can be finicky and small changes can cause vectorization to\n\
               disappear, so code written in C/C++ that relies on the autovectorizer needs to be\n\
               flagged to ensure developers do not modify it and unwittingly disable the vectorization.\n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5561\"></a>The supplied plug-in <span class=\"code\" translate=\"no\">sseDeformer</span> shows a simple example of SSE2 code that can be autovectorized by the Intel compiler.\n\
               The example shows an approximate 3x speedup when run on a large polygonal mesh. Note\n\
               that there can be significant overhead in getting the data into the correct format,\n\
               which can sometimes negate any derived performance benefits. Also note that traditional\n\
               threading of this code would be unlikely to be beneficial as the cost of the threading\n\
               overhead might outweigh the savings from threading. Vectorization can be a good alternative\n\
               in such cases. In the ideal case both vectorization and threading would be applied\n\
               to derive maximum possible speedups.\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5560\"></a> \n\
            <h2><a name=\"GUID-11B37791-597E-4DBE-BB25-1C72E59FAC94\"></a>Autoparallelism\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-555F\"></a>Some compilers offer flags that will cause them to attempt to parallelize code automatically.\n\
               These are rarely useful, since once code gets to be significantly time consuming,\n\
               it becomes too difficult for the compiler to analyze statically whether it is threadsafe.\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";