var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-FE0662C0-4F1A-46BE-9828-76656C2BD2E2\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Quick Python Syntax Tips</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FE0662C0-4F1A-46BE-9828-76656C2BD2E2\"></a><div class=\"head\">\n\
            <h1>Quick Python Syntax Tips</h1>\n\
         </div>\n\
         <p><a name=\"GUID-7AF27844-B298-45F3-94D9-D4A5F351D456\"></a>For readers who are somewhat unfamiliar with Python programming, the following list\n\
            contains a few basic tips to quickly understand the Python code syntax used in this\n\
            Learning Path. For a more complete introduction, you may also want to consult <a href=\"http://docs.python.org/tutorial/introduction.html\" target=\"_blank\">The Informal Introduction to Python</a>. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_86394F2EA2A34E0087A1CC8A56E3ED76\"></a> \n\
            <h2><a name=\"GUID-43A0CEE6-21B5-4945-98A4-0FFBDE8A857A\"></a>Comments\n\
            </h2> \n\
            <p><a name=\"GUID-037D74A1-512C-4A68-9428-C987AD6FEEBF\"></a>Single-line comments begin with the pound (<span class=\"code\" translate=\"no\">#</span>) character, and end with a new line character. Multi-line comments are surrounded\n\
               by three single (or double) quotes: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">someVariable = 4 # This assigns 4 to someVariable.\n\
\n\
\'\'\' There are multiple lines \n\
in this comment. \'\'\'\n\
\n\
\"\"\" \n\
Another\n\
multiple\n\
line\n\
comment. \n\
\"\"\" </pre></div> \n\
            <div><a name=\"GUID-88FDF5C3-55F5-4FBA-859F-76EF84B44DC0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Three single (or double) quotes can also be used to create strings that contain newlines\n\
                  or regular quotes. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_46E3ABBE3AAA42B4967B83DDCDC4ADA3\"></a> \n\
            <h2><a name=\"GUID-645A7840-1F31-49B8-B905-ECBD977D6679\"></a>Strings\n\
            </h2> \n\
            <p><a name=\"GUID-169CE961-D083-45C5-9D75-57CA1BDAD220\"></a>Strings can be contained in pairs of either single- or double-quote characters, and\n\
               can be concatenated with the <span class=\"code\" translate=\"no\">+</span> operator. The <span class=\"code\" translate=\"no\">str()</span> function attempts to convert its input into a string representation. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">myString1 = \'some\' + \' string\'\n\
myString2 = \"another \" + \"string\"\n\
\n\
print \'four: \' + str(4) \n\
# \'four: 4\'</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F979EDFF91E24666A5B570F36C81C249\"></a> \n\
            <h2><a name=\"GUID-75467F5B-319D-4BDF-9D8E-FE0DACAC737B\"></a>Lists\n\
            </h2> \n\
            <p><a name=\"GUID-2C3F16D2-7147-493E-B8C5-A3E256062740\"></a>Lists, denoted by a pair of square brackets, are equivalent to dynamic arrays. The\n\
               starting index in a list is <span class=\"code\" translate=\"no\">0</span>. To add to a list, use the <span class=\"code\" translate=\"no\">append()</span> function. The <span class=\"code\" translate=\"no\">len()</span> function returns the length of a list. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">myList = []\n\
myList.append(\'apples\')\n\
myList.append(\'oranges\')\n\
\n\
print myList[1] \n\
# \'oranges\'\n\
\n\
print str( len( myList ) ) \n\
# \'2\'</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_C5018B09718C4B8B91D34C19266CE6BF\"></a> \n\
            <h2><a name=\"GUID-ABBDBF3B-8A07-4233-90D4-6AB57850D7CA\"></a>Dictionaries\n\
            </h2> \n\
            <p><a name=\"GUID-F3CCD566-B4BD-4DB0-B1EC-4FAA5236682B\"></a>Dictionaries are denoted by pairs of curly brackets, and contain key-value pairs (where\n\
               the key is a hashable object, like a string). \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">myDictionary = {}\n\
myDictionary[\'myKey\'] = \'myValue\'\n\
myDictionary[\'myOtherKey\'] = 17\n\
\n\
print str( myDictionary[\'myOtherKey\'] ) \n\
# \'17\'\n\
\n\
print str( myDictionary ) \n\
# \'{\'myKey\': \'myValue\', \'myOtherKey\': 17}\'</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_61AA23AD02A844CE8F51F1CDEF435E85\"></a> \n\
            <h2><a name=\"GUID-46A5CE1E-C16D-4DB7-9830-438D66345DE9\"></a>Tuples\n\
            </h2> \n\
            <p><a name=\"GUID-EEF91969-B955-4D13-A282-F66CDE4C9169\"></a>Tuples are immutable sequences denoted by pairs of parentheses. You may refer to an\n\
               element within a tuple according to its index. The first element in a tuple is indexed\n\
               at zero <span class=\"code\" translate=\"no\">[0]</span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">myTuple = (\'pants\', \'shirt\', 1987)\n\
\n\
print str( myTuple[1] )\n\
# \'shirt\'\n\
\n\
print str( myTuple )\n\
# (\'pants\', \'shirt\', 1987)\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_81D5EDB894554FB78F3FA1A5A1A8C501\"></a> \n\
            <h2><a name=\"GUID-529EF19F-F6D6-423A-A136-F47D6D128921\"></a>Sets\n\
            </h2> \n\
            <p><a name=\"GUID-159FA65F-B4BB-4766-9B51-727B071C0B11\"></a>Sets are unordered collections of unique (hashable) objects. Sets are denoted by curly\n\
               brackets. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">mySet = {\"cat\", \"dog\", \"lizard\", \"emu\"}\n\
\n\
# Print set.\n\
print(mySet)\n\
# set([\'emu\', \'lizard\', \'dog\', \'cat\'])\n\
\n\
print(len(mySet))\n\
# 4\n\
\n\
# Use in-keyword.\n\
if \"lizard\" in mySet:\n\
    print(\"Lizard exists\")\n\
# Lizard exists\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7AFEAEF94F954490955FF3B77D0AD021\"></a> \n\
            <h2><a name=\"GUID-28C73675-B99E-43A8-BF1C-717BD550454C\"></a>Classes, Functions, and Indentation\n\
            </h2> \n\
            <p><a name=\"GUID-F48DE78D-318C-4213-8AED-B366796E8D77\"></a>Consistent indentations are used to identify class, function, and statement bodies\n\
               such as if/else conditions, and for loops. In the code samples we present, one level\n\
               of indentation consists of four space (\' \') characters. Classes are declared using\n\
               the \'<span class=\"code\" translate=\"no\">class</span>\' keyword, while methods and global functions are declared using the \'<span class=\"code\" translate=\"no\">def</span>\' keyword. Note that the first parameter (usually named \'<span class=\"code\" translate=\"no\">self</span>\') of class methods refers to the current instance. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">class myClass:\n\
    \n\
    def __init__(self):\n\
        \'\'\' \n\
        __init__ identifies the class constructor. \n\
        \'\'\'\n\
        pass # The \'pass\' keyword indicates that we do nothing.\n\
\n\
    def doIt(self, myParameter):\n\
        \'\'\'\n\
        This is a method which we have defined as having one\n\
        parameter whose name is myParameter.\n\
        \'\'\'\n\
        for i in range(0, 9): # This will loop 10 times.\n\
            if (i == 0):\n\
                # Print \'Hello World!\' on the first iteration\n\
                print \'Hello World!\'\n\
            else:\n\
                # Print a string representation of myParameter the rest of the time.\n\
                print str( myParameter )\n\
\n\
# This code will be executed once the myClass definition is read.\n\
myClassInstance = myClass()\n\
myClassInstance.doIt( \'some string\' )</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_558319BC35EB48E9BF6967213FDFB8B5\"></a> \n\
            <h2><a name=\"GUID-2CCBCB01-A247-45AA-A183-17642413CCA5\"></a>Exception Handling\n\
            </h2> \n\
            <p><a name=\"GUID-99D3CE71-FEA3-43E1-9590-EBC99382E5B9\"></a>Conventional try/catch/finally exception handling is performed using the \'<span class=\"code\" translate=\"no\">try</span>\' and \'<span class=\"code\" translate=\"no\">except</span>\' keyword sequence. The \'<span class=\"code\" translate=\"no\">else</span>\' and \'<span class=\"code\" translate=\"no\">finally</span>\' keywords are optional. The code following the \'<span class=\"code\" translate=\"no\">else</span>\' keyword is executed if the code following the \'<span class=\"code\" translate=\"no\">try</span>\' keyword executes without exception. The code following the \'<span class=\"code\" translate=\"no\">finally</span>\' keyword is executed regardless of the occurrence of an exception. Note that you\n\
               can throw your own exceptions using the \'<span class=\"code\" translate=\"no\">raise</span>\' keyword. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># This code sample can be found at: http://docs.python.org/tutorial/errors.html\n\
def divide(x, y):\n\
    try:\n\
        result = x / y\n\
    except ZeroDivisionError:\n\
        print \"division by zero!\"\n\
    else:\n\
        print \"result is\" + result\n\
    finally:\n\
        print \"executing finally clause\"</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";