var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-AB1607E6-7681-42B3-9FBB-832EE4ADF8D9\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Introduction to Manipulators</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AB1607E6-7681-42B3-9FBB-832EE4ADF8D9\"></a><div class=\"head\">\n\
            <h1>Introduction to Manipulators</h1>\n\
         </div>\n\
         <p><a name=\"GUID-644FEED1-182E-4CD1-953E-5A4F486E2897\"></a>The topics in this section describe the API classes and interfaces used to write manipulators\n\
            in the Legacy Default Viewport. For information on how to draw manipulators in Viewport\n\
            2.0, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-E8A490EC-7538-4A34-8C03-55E56EE92E39.htm\">3.10 Manipulators</a></span>. \n\
         </p>\n\
         <p><a name=\"GUID-E1373681-1DDC-44CD-83EF-040A531E3182\"></a> A manipulator is a node that draws itself using 3D graphical elements, which respond\n\
            to user events. Manipulators translate the user events into values that are used for\n\
            modifying the attribute values of other nodes in a scene. \n\
         </p>\n\
         <p><a name=\"GUID-84AD980E-2779-4C20-9E5D-6503E5326E09\"></a>The attribute values of a node can be changed through ways such as the Channel Box\n\
            and Graph Editor, but manipulators provide a more intuitive way for changing attribute\n\
            values. The manipulator translates modifications to the visual controls into values\n\
            that are applied directly to the node attributes. Unlike the other dependency graph\n\
            nodes, a manipulator modifies the attribute values directly and not through the standard\n\
            plug and connection mechanism. \n\
         </p>\n\
         <p><a name=\"GUID-322E0804-F35A-4576-84BE-EDCB4DE5C9C8\"></a>Manipulators can also be used as an interactive tool to manipulate objects or custom\n\
            nodes in a scene. Using custom manipulators, you can create different types of custom\n\
            tools such as modeling or rigging tools. \n\
         </p>\n\
         <p><a name=\"GUID-9E1C3146-2746-42C5-91F6-BA53217244D4\"></a>You can use manipulators in the following ways: \n\
         </p><a name=\"UL_F59D5E83B62647D984D8999E93322574\"></a><ul>\n\
            <li>Create a manipulator on any node in the current scene at any time. </li>\n\
            <li>Create and assign a manipulator for a specific type of object. </li>\n\
            <li>Create a context tool and associate the manipulator to the context tool. Whenever\n\
               the context tool is active, the manipulator becomes active and ready for use. \n\
            </li>\n\
         </ul>\n\
         <div><a name=\"GUID-45551630-1888-4641-936D-8978FD19FCF0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Manipulators are only active when the <span class=\"MenuCascade\" id=\"GUID-DB8F6899-A529-4C75-A6B3-29FD34C9878F\">Show Manipulator Tool</span> or the associated context is active, and the corresponding object is selected. \n\
            </div>\n\
         </div>\n\
         <p><a name=\"GUID-C8E4C282-FE2C-41EB-9FBC-0C2BEF1A6427\"></a>Manipulators are not visible in the Hypergraph or Outliner even though they are nodes\n\
            and they are not added to the Maya selection list. Additionally, their attributes\n\
            are not accessible from MEL or the Attribute Editor and they are not written to file.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-3D64FAC1-A6B8-4286-BA9B-B3B2D1F8BACE\"></a>Manipulators can operate on data types that range from integer and floating point\n\
            values to matrix data and they can operate on one or more attribute values at the\n\
            same time. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";