var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2016-10-25\">\n\
      <meta name=\"topicid\" content=\"GUID-E15D1623-844B-4FB8-BB0B-E9B0BD076CFF\">\n\
      <meta name=\"indexterm\" content=\"manipulators, API: writing\">\n\
      <meta name=\"indexterm\" content=\"API manips: writing\">\n\
      <meta name=\"indexterm\" content=\"container manipulators: in API\">\n\
      <meta name=\"indexterm\" content=\"manipulators, API: container\">\n\
      <meta name=\"indexterm\" content=\"API manips: container manipulators\">\n\
      <meta name=\"indexterm\" content=\"base manipulators: in API\">\n\
      <meta name=\"indexterm\" content=\"manipulators, API: base\">\n\
      <meta name=\"indexterm\" content=\"API manips: base manipulators\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Writing a Manipulator</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E15D1623-844B-4FB8-BB0B-E9B0BD076CFF\"></a><div class=\"head\">\n\
            <h1>Writing a Manipulator</h1>\n\
         </div>\n\
         <p><a name=\"GUID-AAFB78FE-2C9F-4AB8-A88C-08220D21CDE5\"></a>You can create manipulators in the following ways: <a name=\"UL_D1766E60C6DE4D39A2965D6EF5076131\"></a><ul>\n\
               <li>Create a base manipulator on any node in the current scene. </li>\n\
               <li>Create a composite manipulator by adding base manipulators to a manipulator container.\n\
                  \n\
               </li>\n\
               <li>Create a new type of manipulator node by using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxManipulatorNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_manipulator_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxManipulatorNode</a></span> class and define custom drawing and picking of the manipulator node. \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F14E7\"></a> Writing a manipulator involves defining a subclass of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxManipContainer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_manip_container.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxManipContainer</a></span> class, adding base manipulators to the container manipulator, and defining associations\n\
            between the manipulator and the attributes on the nodes they affect. Even if your\n\
            manipulator consists of only one base manipulator, it is necessary to create a container\n\
            manipulator and add the base manipulator to it. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F14E9\"></a>  Container manipulators are composed of one or more base manipulators. When base manipulators\n\
            are added to a container manipulator, they are referred to as children of the container\n\
            manipulator, and are added using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxManipContainer::createChildren()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_manip_container.html#a5f6e1ab823f87eddad380cd85f61293c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxManipContainer::createChildren()</a></span> method. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F14EC\"></a>The association between the manipulator and the corresponding plugs on a node must\n\
            be defined. The nature of the association between the manipulator and the plugs might\n\
            be simple or complex. For simple associations, there is a direct correspondence between\n\
            a manipulator value and the corresponding plug. Conversion functions are used for\n\
            complex associations. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";